systems = {}
current = 1
function love.load()
	love.graphics.setMode( 650, 650, false, true, 0 )
	--load options from file
	local options = {}
	for line in love.filesystem.lines ("options.txt") do
		table.insert (options, line)


	end

	--set variables = to values from file
	health=options[1]
	fuel=options[2]
	damage=options[3]

	--make the values ints
	health1=health*1
	fuel1=fuel*1
	damage1=damage*1


	love.graphics.setMode( 1280, 720, false, true, 0 )
	world = love.physics.newWorld( 1280, 720 )
	world:setGravity( 0, 100 )
	world:setMeter( 64 )
	world:setCallbacks(add, persist, rem, result)


	winH = love.graphics.getHeight()
	winW = love.graphics.getWidth()
	wind = math.random(-10,10)
	tankW = 64
	tankH = 32
	tankVelocity = 1 --reticle speed
	turnCount = 0
	player = "Player One"

	bodies = {}
	shapes = {}
	tanks = {}

	--graphics
	OneVict = love.graphics.newImage("p1.png")
	TwoVict = love.graphics.newImage("p2.png")
	playerOne = love.graphics.newImage("tank1.png")
	playerTwo = love.graphics.newImage("tank2.png")

	--audio
	shoot = love.audio.newSource("shoot.wav")
	hit = love.audio.newSource("hit.wav")


	--walls
	bodies["left_wall"] = love.physics.newBody( world, 0, winH/2, 0, 0 )
	shapes["left_wall"] = love.physics.newRectangleShape( bodies["left_wall"], 0, 0, 7, winH, 0 )
	shapes["left_wall"]:setData( "l_wall" )

	bodies["right_wall"] = love.physics.newBody( world, winW, winH/2, 0, 0 )
	shapes["right_wall"] = love.physics.newRectangleShape( bodies["right_wall"], 0, 0, 7, winH, 0 )
	shapes["right_wall"]:setData( "r_wall" )

	bodies["top_wall"] = love.physics.newBody( world, winW/2, 0, 0, 0 )
	shapes["top_wall"] = love.physics.newRectangleShape( bodies["top_wall"], 0, 0, winW, 7, 0 )
	shapes["top_wall"]:setData( "t_wall" )

	bodies["bottom_wall"] = love.physics.newBody( world, winW/2, winH, 0, 0 )
	shapes["bottom_wall"] = love.physics.newRectangleShape( bodies["bottom_wall"], 0, 0, winW, 7, 0 )
	shapes["bottom_wall"]:setData( "b_wall" )
	--/walls

	--tanks
	tanks["Player One"] = { angle = 90 , fuel =fuel1, health =health1, xr, yr, xp, yp,power=0, ammo = 1}
	tanks["Player Two"] = { angle = 90 , fuel =fuel1 , health =health1, xr, yr, xp, yp,power=0, ammo = 1}

	--ground
	bodies["ground"] = love.physics.newBody(world,0,winH*(3/4),0,0)
	shapes["ground"] = love.physics.newRectangleShape(bodies["ground"],winW/2,winH*(3/8),winW,winH*(3/4),0)
	shapes["ground"]:setData("ground")

	--playerone
	bodies["Player One"] = love.physics.newBody(world,10,10,50,0)
	shapes["Player One"] = love.physics.newRectangleShape(bodies["Player One"],0,0,tankW,tankH,0)
	shapes["Player One"]:setData("Player One")

	--playertwo
	bodies["Player Two"] = love.physics.newBody(world,winW-tankW,0,50,0)
	shapes["Player Two"] = love.physics.newRectangleShape(bodies["Player Two"],0,0,tankW,tankH,0)
	shapes["Player Two"]:setData("Player Two")

	--bullet
	bodies["Bullet"]=love.physics.newBody(world,winW/2,50, 10, 0 )
	shapes["Bullet"] = love.physics.newCircleShape( bodies["Bullet"], 0, 0, 10)
	shapes["Bullet"]:setData("Bullet")
	bodies["Bullet"]:setBullet( status )
	bodies["Bullet"]:setAllowSleeping(true)

	--particle stuff
	part1 = love.graphics.newImage("part1.png");
	cloud = love.graphics.newImage("cloud.png");
	square = love.graphics.newImage("square.png")
	font = love.graphics.newFont(love._vera_ttf, 10)

	love.graphics.setFont(font)
	love.graphics.setColor(200, 200, 200);

	local p = love.graphics.newParticleSystem(part1, 1000)

	p = love.graphics.newParticleSystem(part1, 1000)
	p:setEmissionRate(1000)
	p:setSpeed(300, 400)
	p:setSize(2, 1)
	p:setColor(220, 105, 20, 255, 194, 30, 18, 0)
	p:setPosition(400, 300)
	p:setLifetime(0.1)
	p:setParticleLife(0.2)
	p:setDirection(0)
	p:setSpread(360)
	p:setTangentialAcceleration(1000)
	p:setRadialAcceleration(-2000)
	p:stop()
	table.insert(systems, p)
end

function love.update(dt)

	world:update(dt)
	systems[current]:update(dt)
	tanks["Player One"].xr, tanks["Player One"].yr = getReticalCoordinate(bodies["Player One"]:getX(), bodies["Player One"]:getY() - tankH ,tanks["Player One"].angle,50)
	tanks["Player Two"].xr, tanks["Player Two"].yr = getReticalCoordinate(bodies["Player Two"]:getX(), bodies["Player Two"]:getY() - tankH,tanks["Player Two"].angle,50)
	--determine turn
	if turnCount%2 == 0 then
		player = "Player One"
	else
	player = "Player Two"
	end

	--apply wind force
	bodies["Bullet"]:applyForce(wind,0);

	--particle
	particle()



	--key presses
	--move
	if love.keyboard.isDown( "d" ) then
		if tanks[player].fuel >0 and bodies[player]:getX() <= winW-tankW then
		bodies[player]:setX(bodies[player]:getX()+tankVelocity);
		tanks[player].fuel = tanks[player].fuel - 1
		end

	elseif love.keyboard.isDown( "a" ) then
		if tanks[player].fuel >0 and bodies[player]:getX() >= 0 then
		bodies[player]:setX(bodies[player]:getX()-tankVelocity);
		tanks[player].fuel = tanks[player].fuel - 1
		end
	--angle
	elseif love.keyboard.isDown( "w" ) then
		if tanks[player].angle < 180 then
		tanks[player].angle = tanks[player].angle + 1
		end

	elseif love.keyboard.isDown( "s" ) then
		if tanks[player].angle > 0 then
		tanks[player].angle = tanks[player].angle - 1
		end
	--tank  power
	elseif love.keyboard.isDown( "up" ) then
		if tanks[player].power < 150 then
			tanks[player].power=tanks[player].power+1
		end
	elseif love.keyboard.isDown( "down" ) then
		if tanks[player].power > 0 then
			tanks[player].power=tanks[player].power-1
		end

	--shoot
	elseif love.keyboard.isDown( " " ) then



		tanks[player].xp , tanks[player].yp = getReticalCoordinate(0,0, tanks[player].angle,tanks[player].power)
		if(tanks[player].ammo ~= 0) then
			love.audio.stop()
			love.audio.play(shoot)

			bodies["Bullet"]:wakeUp()
			bodies["Bullet"]:setX(tanks[player].xr)
			bodies["Bullet"]:setY(tanks[player].yr)



			bodies["Bullet"]:applyImpulse( tanks[player].xp,tanks[player].yp)

			tanks[player].ammo = 0
		end






	end

end

--aiming
function getReticalCoordinate( x, y, angle, radius)
	xc = x+(radius*math.cos((angle*math.pi)/180))
	yc = y-(radius*math.sin((angle*math.pi)/180))
	return xc,yc
end


function love.draw()


--calculate whene to draw square on tanks bodies
	if(tanks["Player One"].health <= 0) then
		--player two wins
		love.graphics.draw(TwoVict, x, y)


	elseif(tanks["Player Two"].health <= 0) then
		--player one wins
		love.graphics.draw(OneVict, x, y)


	else





		local x1, y1, x2, y2, x3, y3, x4, y4 = shapes["Player One"]:getBoundingBox()
		local width = x3 - x2 --calculate the width player one
		local height = y1 - y2 --calculate the height


		love.graphics.print(player,20,20,0,1,1)



		love.graphics.setColor(34,139,34)
		love.graphics.rectangle("fill",bodies["ground"]:getX(),bodies["ground"]:getY(),winW,winH*(3/4))

		love.graphics.setColor(255,0,0)

		--draw tanks
		love.graphics.draw(playerOne, bodies["Player One"]:getX()-width/2, bodies["Player One"]:getY()-height/2)
		--love.graphics.rectangle("fill", bodies["Player One"]:getX()-width/2, bodies["Player One"]:getY()-height/2,64,32,0)
		love.graphics.print("fuel: "..tanks["Player One"].fuel,10,winH-20,0,2,2)
		love.graphics.print("angle: "..tanks["Player One"].angle,10,winH-50,0,2,2)
		love.graphics.print("power: "..tanks["Player One"].power,10,winH-80,0,2,2)
		love.graphics.print("X",tanks["Player One"].xr,tanks["Player One"].yr,0,2,2)


		love.graphics.setColor(0,0,255)

		--draw tanks
		love.graphics.draw(playerTwo, bodies["Player Two"]:getX()-width/2, bodies["Player Two"]:getY()-height/2)
		--love.graphics.rectangle("fill", bodies["Player Two"]:getX()-width/2, bodies["Player Two"]:getY()-height/2,64,32,0)
		love.graphics.print("fuel: "..tanks["Player Two"].fuel,winW-130,winH-20,0,2,2)
		love.graphics.print("angle: "..tanks["Player Two"].angle,winW-130,winH-50,0,2,2)
		love.graphics.print("power: "..tanks["Player Two"].power,winW-130,winH-80,0,2,2)
		love.graphics.print(tanks["Player One"].health,bodies["Player One"]:getX()-20,bodies["Player One"]:getY()+10,0,2,2)
		love.graphics.print("X",tanks["Player Two"].xr,tanks["Player Two"].yr,0,2,2)

		love.graphics.setColor(255,0,0)
		love.graphics.print(tanks["Player Two"].health,bodies["Player Two"]:getX()-20,bodies["Player Two"]:getY()+10,0,2,2)

		love.graphics.setColor(200,200,200)

		love.graphics.circle("fill",bodies["Bullet"]:getX(),bodies["Bullet"]:getY(),shapes["Bullet"]:getRadius(),1000)
		love.graphics.print(text,0,12)
		love.graphics.print("Wind: "..wind,winW/2,40,0,2,2)
		--love.graphics.print("AMMO player one:  "..tanks["Player One"].ammo,winW/2,40)

		--love.graphics.print("AMMO player Two:  "..tanks["Player Two"].ammo,winW/2,60)
		love.graphics.setColorMode("modulate")
		love.graphics.setBlendMode("additive")

		love.graphics.draw(systems[current], 0, 0)
	end

end

function particle()

	systems[current]:setPosition( bodies["Bullet"]:getX( ), bodies["Bullet"]:getY( ))

	systems[current]:start()
end

function add(a, b, coll)
	if((b =="Player One" or b == "Player Two" or a == "Player One" or a == "Player Two") and (a == "Bullet" or b =="Bullet"))
	then
		--text = a.." collding with "..b.." at an angle of "..coll:getNormal().."\n"
		love.audio.stop()
		love.audio.play(hit)

		tanks[a].health = tanks[a].health - damage1

		tanks[player].ammo = 1

		turnCount = turnCount + 1

		tanks[player].fuel = fuel1

		wind = math.random(-10,10)
		bodies["Bullet"]:putToSleep()






	elseif(b=="ground" or a == "ground") then
		love.audio.stop()
		love.audio.play(hit)


		tanks[player].ammo = 1



		wind = math.random(-10,10)
		turnCount = turnCount + 1

		tanks[player].fuel = fuel1

		bodies["Bullet"]:putToSleep()




	else
		text =""
	end


end
